import P, R, C, Ct, V from require 'lpeg'

pin_number_grammar = P {
    'everything'
    everything: Ct V'term' ^ 0
    term: V'number' + V'letter'
    number: C(R'09' ^ 1) / tonumber
    letter: C(P 1)
}

pin_number_sort = (a, b) ->
    a = pin_number_grammar\match a
    b = pin_number_grammar\match b
    for i, av in ipairs a
        if av != b[i]
            if type(av) != type(b[i])
                return type(av) < type(b[i])
            return av < b[i]
    return #a < #b

pads = {}

for l in assert io.lines arg[1]
    name = l\match'^  %(pad (%S+)'
    if name
        pads[name] = true

for l in assert io.lines 'symbols.lib'
    name = l\match '^X %S+ (%S+)'
    if name
        pads[name] = nil

pads = [ k for k in pairs pads ]
table.sort pads, pin_number_sort

for i, name in ipairs pads
    print 'X unknown %s 1000 %d 100 R 50 50 1 1 I N'\format name, -100 * i

